package reborncore.common.powerSystem;

import cofh.api.energy.IEnergyConnection;
import cofh.api.energy.IEnergyHandler;
import cofh.api.energy.IEnergyProvider;
import cofh.api.energy.IEnergyReceiver;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockPos;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.IEnergyInterfaceTile;
import reborncore.common.tile.TileMachineBase;

import java.util.Random;

/**
 * This is done in a different class so the updateEntity can be striped for ic2 and this one will still get called.
 */
public abstract class RFProviderTile extends TileMachineBase implements IEnergyReceiver, IEnergyProvider, IEnergyInterfaceTile {


    Random random = new Random();

    @Override
    public void updateEntity() {
        super.updateEntity();
        if (field_145850_b.field_72995_K) {
            return;
        }
        sendPower();
    }

    public void sendPower() {
        if (!PowerSystem.RFPOWENET) {
            return;
        }
        for (EnumFacing direction : EnumFacing.values()) {
            int extracted = getEnergyStored(direction);

            TileEntity tile = field_145850_b.func_175625_s(new BlockPos(func_174877_v().func_177958_n() + direction.func_82601_c(), func_174877_v().func_177956_o() + direction.func_96559_d(), func_174877_v().func_177952_p() + direction.func_82599_e()));
            if (isPoweredTile(tile, direction)) {
                if (canProvideEnergy(direction)) {
                    if (tile instanceof IEnergyReceiver) {
                        IEnergyReceiver handler = (IEnergyReceiver) tile;
                        int neededRF = handler.receiveEnergy(
                                direction.func_176734_d(),
                                extracted, false);

                        extractEnergy(direction.func_176734_d(), neededRF, false);
                    }
                }

            }
        }
    }

    public boolean isPoweredTile(TileEntity tile, EnumFacing side) {
        if (tile == null) {
            return false;
        } else if (tile instanceof IEnergyHandler || tile instanceof IEnergyReceiver) {
            return ((IEnergyConnection) tile).canConnectEnergy(side.func_176734_d());
        } else {
            return false;
        }
    }
}
